<template>
  <!-- Button has a "on" value of true -->
  <!-- It has the type-X class to ge the --type-color variable -->
  <v-btn
    :value="true"
    class="creation-button"
    :class="getCssClasses(template)"
    :input-value="active"
    :elevation="active ? 2 : 0"
    active-class="active"
    :large="active"
    ripple
    rounded
    v-on="$listeners"
  >
    {{ template.type === 'Pattern' ? template.tag : `${template.tag} (${template.type})` }}
    <div class="creation-button-num">
      {{ keyNum }}
    </div>
  </v-btn>
</template>
<script lang="ts">
import {
  Vue, Component, Prop, Watch,
} from 'vue-property-decorator';
import type { LabelTemplate } from '@/data';
import { FilterStyleGenerator } from '@/logic/FilterStyleGenerator';

@Component({})
export default class CreationButton extends Vue {
  @Prop({ required: true })
  template!: LabelTemplate;

  getCssClasses = FilterStyleGenerator.getCssClassNames;

  @Prop({ required: true })
  selectedTemplate!: LabelTemplate;

  @Prop({ required: true })
  keyNum!: number;

  active = false;

  mounted() {
    this.onSelectionChange();
  }

  @Watch('selectedTemplate')
  onSelectionChange() {
    this.active = this.template.type === this.selectedTemplate.type
      && this.template.tag === this.selectedTemplate.tag;
  }
}
</script>
<style scoped lang="scss">
// Not scoped to affect v-btn

// Set the background color to the label
.creation-button {
  &::before {
    background-color: var(--label-color, light-grey);
    opacity: 0.3;
  }
  // Set the active buttons to be more saturated
  &.active::before {
    opacity: 0.4;
  }
  // Set the active button to be outlined
  &.active {
    border-width: 3 !important;
    border-style: solid !important;
    border-color: var(--label-color, light-grey) !important
  }
  // Remove the margin on active buttons
  // so that even if they are bigger they don't take more space
  &.active {
    margin-top: 3px !important;
    margin-bottom: 3px !important;
    margin-left: 3.5px !important;
    margin-right: 3.5px !important;
  }
  &-num {
    display:flex;
    align-items: center;
    justify-content: center;
    background:#333;
    opacity: 0.5;
    border-radius: 100%;
    width: 20px;
    height: 20px;
    color: white;
    position:absolute;
    right:-18px;
    bottom:-18px;
  }
}
</style>
